#### Data format:
*(Ids are temporarily generated in Python import script as a row number from the original csv file.)* 
| id | cert_info_link                                                                         | not_valid_before | not_valid_after | cert_common_name                        | cert_authority | log_type     |
|----|----------------------------------------------------------------------------------------|------------------|-----------------|-----------------------------------------|----------------|--------------|
| 0  | http://ct.googleapis.com/logs/xenon2020/ct/v1/get-entries?start=57610940&end=57610940 | 1573257600       | 1581119999      | thesmartlocal0901.firstcomdemolinks.com | cPanel, Inc.   | X509LogEntry |

#### How to run CLI:
1. https://aws.amazon.com/cli/ - on Windows download, on Linux run in a command line: ```pip install awscli```  
2. Then both on Windows and Linux: ```aws configure ```

- Choose some region from list - https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/using-regions-availability-zones.html , we used: ```eu-central-1```
- Access keys: ```AKIASNAN4NLHAWWHDQ2F```, ```64fOcamUoHvmHe0nkwXkAnXF9kK9RTPKKzIpIPAP``` (https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/SettingUp.DynamoWebService.html)
- Output: ```json```

3. Try if these commands get some output: ```aws ec2 describe-instances```, ```aws dynamodb --version``` (https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/Tools.CLI.html)

https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/getting-started-step-1.html
https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_AttributeDefinition.html

4. Create a table: 

https://docs.aws.amazon.com/amazondynamodb/latest/APIReference/API_CreateTable.html
https://docs.aws.amazon.com/amazondynamodb/latest/developerguide/HowItWorks.CoreComponents.html - how do indexes work

Two approaches, first using command line:
```
aws dynamodb create-table \
    --table-name Certificates \
    --attribute-definitions \
        AttributeName=id,AttributeType=S \
        AttributeName=cert_info_link,AttributeType=S \
        AttributeName=not_valid_before,AttributeType=N \
        AttributeName=not_valid_after,AttributeType=N \
        AttributeName=cert_common_name,AttributeType=S \
        AttributeName=cert_authority,AttributeType=S \
        AttributeName=log_type,AttributeType=S \
    --key-schema \
        AttributeName=id,KeyType=HASH \
        AttributeName=cert_common_name,KeyType=RANGE \
    .... <local secondary indexes here>
--provisioned-throughput \
        ReadCapacityUnits=1,WriteCapacityUnits=1
```

Second approach, JSON: 
```
{
	"TableName": "Certificates",
	"KeySchema": [
		{ "AttributeName": "id", "KeyType": "HASH" },
		{ "AttributeName": "cert_common_name", "KeyType": "RANGE" }
	],
	"LocalSecondaryIndexes": [
		{ "IndexName": "cert_authority_index",
		  "KeySchema": [
			  {
			  	"AttributeName": "id",
				"KeyType" : "HASH"
			  },
			  {
				"AttributeName": "cert_authority",
				"KeyType" : "RANGE"
			  }
		  ],
		  "Projection": {
			  "ProjectionType": "KEYS_ONLY"
		  }
		},
		{ "IndexName": "cert_info_link_index",
		  "KeySchema": [
        		  {
        			"AttributeName": "id",
        			"KeyType" : "HASH"
        		  },
        		  {
        			"AttributeName": "cert_info_link",
        			"KeyType" : "RANGE"
        		  }
      		  ],
      		  "Projection": {
        		"ProjectionType": "KEYS_ONLY"
        	  }
      		},
	    	{ "IndexName": "not_valid_before_index",
		  "KeySchema": [
        		  {
        			"AttributeName": "id",
        			"KeyType" : "HASH"
        		  },
        		  {
        			"AttributeName": "not_valid_before",
        			"KeyType" : "RANGE"
        		  }
      		  ],
      		  "Projection": {
        		"ProjectionType": "KEYS_ONLY"
        	  }
      		},
      		{ "IndexName": "not_valid_after_index",
		  "KeySchema": [
        		  {
        			"AttributeName": "id",
        			"KeyType" : "HASH"
        		  },
        		  {
        			"AttributeName": "not_valid_after",
        			"KeyType" : "RANGE"
        		  }
      		  ],
      		  "Projection": {
        		"ProjectionType": "KEYS_ONLY"
        	  }
      		},
          	{ "IndexName": "log_type_index",
		  "KeySchema": [
        		  {
        			"AttributeName": "id",
        			"KeyType" : "HASH"
        		  },
        		  {
        			"AttributeName": "log_type",
        			"KeyType" : "RANGE"
        		  }
      		  ],
      		  "Projection": {
        		"ProjectionType": "KEYS_ONLY"
        	  }
      		}
	],
	"AttributeDefinitions": [
		{ "AttributeName": "id", "AttributeType": "N" },
		{ "AttributeName": "cert_info_link", "AttributeType": "S" },
		{ "AttributeName": "not_valid_before", "AttributeType": "N" },
		{ "AttributeName": "not_valid_after", "AttributeType": "N" },
		{ "AttributeName": "cert_common_name", "AttributeType": "S" },
		{ "AttributeName": "cert_authority", "AttributeType": "S" },
		{ "AttributeName": "log_type", "AttributeType": "S" }
	],
	"ProvisionedThroughput": {
		"ReadCapacityUnits": 1,
		"WriteCapacityUnits": 1
	}
}

```
If a valid JSON table schema is in a separated file, the table can be created using this command: ```aws dynamodb create-table --cli-input-json file://certificates_table.json```

5. Check if the table was created: ```aws dynamodb describe-table --table-name Certificates | grep TableStatus```
- Delete table: ```aws dynamodb delete-table --table-name Certificates```
7. Data import: ```py import_data.py```, ```python3 import_data.py``` (pi -m pip install boto3, pip3 install boto3)

The script basically does this for each row from sample.csv:
```
aws dynamodb put-item \
--table-name Certificates  \
--item \
    '{"id": {"N": "0"}, "cert_info_link": {"S": "http://ct.googleapis.com/logs/xenon2020/ct/v1/get-entries?start=57610940&end=57610940"}, "not_valid_before": {"N": "1573257600"}, "not_valid_after": {"N": "1581119999"}, "cert_common_name": {"S": "thesmartlocal0901.firstcomdemolinks.com"}, "cert_authority": {"S": "cPanel, Inc."}, "log_type": {"S": "X509LogEntry"}}'
```

- List all tables in database: ```aws dynamodb list-tables```

TODO: Change schema so that more complex queries can be done, right now we need to know id and cert_common_name and that is not exactly ideal:

Try these two command to check that an item is in fact correctly returned:

```
aws dynamodb put-item --table-name Certificates --item '{"id": {"N": "420"}, "cert_info_link": {"S": "http://ct.googleapis.com/logs/xenon2020/ct/v1/get-entries?start=57610940&end=57610940"}, "not_valid_before": {"N": "1573257600"}, "not_valid_after": {"N": "1581119999"}, "cert_common_name": {"S": "denca"}, "cert_authority": {"S": "cPanel, Inc."}, "log_type": {"S": "X509LogEntry"}}'
```
```
aws dynamodb get-item --consistent-read --table-name Certificates --key '{ "id": {"N": "420"}, "cert_common_name": {"S": "denca"}}'
```