import boto3
from boto3.dynamodb.conditions import Attr

dynamodb = boto3.resource('dynamodb')
table = dynamodb.Table('TestCertificates')

def get_cert_authority_column(equal):
    response = []
    if equal:
        response = table.scan(
                FilterExpression=Attr('log_type').eq('PrecertLogEntry') 
                )['Items']
    else:
        response = table.scan(
                FilterExpression=Attr('log_type').ne('PrecertLogEntry')
                )['Items']

    result = []
    for item in response:
        result.append(item['cert_authority'])

    return result

def add_response_to_dictionary(dictionary, authorities, index):
    for authority in authorities:
        if authority not in dictionary:
            dictionary[authority] = [0, 0]
        dictionary[authority][index] += 1 

def print_result(dictionary):
    print("Certificate authorities (cert_authority) cert/precert ratio:")
    for elem in dictionary:
        print(" > {0:40s} {1}/{2}".format(elem, dictionary[elem][0], dictionary[elem][1]))
    print("There are ", len(dictionary), " authorities in total.")

if __name__ == '__main__':
    response_precert = get_cert_authority_column(True)
    response_not_precert = get_cert_authority_column(False)
    response_dictionary = {}
    add_response_to_dictionary(response_dictionary, response_precert, 1)
    add_response_to_dictionary(response_dictionary, response_not_precert, 0)
    print_result(response_dictionary)

