import Vue from 'vue';
import VueWait from 'vue-wait';
import Vuetify from 'vuetify';

// declare module "vuetify/lib";

// VeeValidate
declare module 'vue/types/vue' {
  // Vuetify form validation options
  // Accessible on v-form through this.$refs.<formName>
  interface Vue {
    validate?: any;
    reset?: any;
    resetValidation: any;
  }
}

declare module 'vue/types/vue' {
  // Global properties can be declared
  // on the `VueConstructor` interface
  interface VueConstructor {
    $wait: VueWait;
  }
  interface Vue {
    $wait: VueWait;
  }
}

// ComponentOptions is declared in types/options.d.ts
declare module 'vue/types/options' {

  interface ComponentOptions<V extends Vue> {
    wait?: VueWait;
  }
}

declare module 'vuetify/lib' {

}
